#ifndef APOP_BOOT_H
#define APOP_BOOT_H

#undef __BEGIN_DECLS    /* extern "C" stuff cut 'n' pasted from the GSL. */
#undef __END_DECLS
#ifdef __cplusplus
# define __BEGIN_DECLS extern "C" {
# define __END_DECLS }
#else
# define __BEGIN_DECLS /* empty */
# define __END_DECLS /* empty */
#endif

#include "variadic.h"

__BEGIN_DECLS

apop_data * apop_jackknife_cov(apop_data *data, apop_model model);
#ifdef APOP_NO_VARIADIC
 apop_data * apop_bootstrap_cov(apop_data *data, apop_model model, gsl_rng* rng, int iterations);
#else
 apop_data * apop_bootstrap_cov_base(apop_data *data, apop_model model, gsl_rng* rng, int iterations);
 apop_varad_declare(apop_data *, apop_bootstrap_cov, apop_data *data; apop_model model; gsl_rng* rng; int iterations);
#define apop_bootstrap_cov(...) apop_varad_link(apop_bootstrap_cov, __VA_ARGS__)
#endif
gsl_rng *apop_rng_alloc(int seed);

__END_DECLS
#endif
