#ifndef APOP_OUTPUT_H
#define APOP_OUTPUT_H
#include <gsl/gsl_matrix.h>
#include "db.h"
#include "variadic.h"
#include "types.h"
#include "stats.h"
#include "linear_algebra.h"

#undef __BEGIN_DECLS
#undef __END_DECLS
#ifdef __cplusplus
# define __BEGIN_DECLS extern "C" {
# define __END_DECLS }
#else
# define __BEGIN_DECLS /* empty */
# define __END_DECLS /* empty */
#endif

__BEGIN_DECLS

void apop_plot_line_and_scatter(apop_data *data, apop_model *est, char *);
#ifdef APOP_NO_VARIADIC
 void apop_histogram_plot(apop_model *hist, char *outfile);
#else
 void apop_histogram_plot_base(apop_model *hist, char *outfile);
 apop_varad_declare(void, apop_histogram_plot, apop_model *hist; char *outfile);
#define apop_histogram_plot(...) apop_varad_link(apop_histogram_plot, __VA_ARGS__)
#endif
#ifdef APOP_NO_VARIADIC
 void apop_plot_histogram(gsl_vector *data, size_t bins, char *outfile);
#else
 void apop_plot_histogram_base(gsl_vector *data, size_t bins, char *outfile);
 apop_varad_declare(void, apop_plot_histogram, gsl_vector *data; size_t bins; char *outfile);
#define apop_plot_histogram(...) apop_varad_link(apop_plot_histogram, __VA_ARGS__)
#endif
#ifdef APOP_NO_VARIADIC
 void apop_histogram_print(apop_model *h, char *outfile);
#else
 void apop_histogram_print_base(apop_model *h, char *outfile);
 apop_varad_declare(void, apop_histogram_print, apop_model *h; char *outfile);
#define apop_histogram_print(...) apop_varad_link(apop_histogram_print, __VA_ARGS__)
#endif
#ifdef APOP_NO_VARIADIC
 void apop_plot_lattice(const apop_data *d, char *outfile);
#else
 void apop_plot_lattice_base(const apop_data *d, char *outfile);
 apop_varad_declare(void, apop_plot_lattice, const apop_data *d; char *outfile);
#define apop_plot_lattice(...) apop_varad_link(apop_plot_lattice, __VA_ARGS__)
#endif
#ifdef APOP_NO_VARIADIC
 void apop_plot_qq(gsl_vector *v, apop_model *m, char *outfile, size_t bins, gsl_rng *r);
#else
 void apop_plot_qq_base(gsl_vector *v, apop_model *m, char *outfile, size_t bins, gsl_rng *r);
 apop_varad_declare(void, apop_plot_qq, gsl_vector *v; apop_model *m; char *outfile; size_t bins; gsl_rng *r);
#define apop_plot_qq(...) apop_varad_link(apop_plot_qq, __VA_ARGS__)
#endif

void apop_matrix_print(gsl_matrix *data, char *file);
void apop_vector_print(gsl_vector *data, char *file);
void apop_data_print(apop_data *data, char *file);

void apop_matrix_show(const gsl_matrix *data);
void apop_vector_show(const gsl_vector *data);
void apop_data_show(const apop_data *data);
__END_DECLS
#endif
